/*
** debug.c for elfsh
** 
** Started on  Thu Apr  3 21:36:55 2003 mayhem
** Last update Thu May 15 03:39:16 2003 mayhem
*/
#include "libelfsh.h"



/* Debug : print the section list */
int		elfsh_print_sectlist(elfshobj_t *obj, char *label)
{
  elfshsect_t	*actual;
  u_int		index;
  u_char	*data;

  printf(" [SCTLIST][%s]\n", label);
  for (index = 0, actual = obj->sectlist; 
       actual != NULL; 
       index++, actual = actual->next)
    {
      data = (actual->data == NULL ? "\xFF\xFF\xFF" : actual->data);
      printf(" [%03u] %-15s HDRNAM: %-15s BYTES[%02X %02X %02X] P(%08X) A(%08X) N(%08X) SCTIDX(%03u) HDRFOFF:%08u SZ:%08u\n",
	     index, actual->name,
	     elfsh_get_section_name(obj, actual),
	     (u_int) data[0], 
	     (u_int) data[1], 
	     (u_int) data[2],
	     (u_int) actual->prev, 
	     (u_int) actual,
	     (u_int) actual->next, 
	     actual->index, 
	     actual->shdr->sh_offset,
	     actual->shdr->sh_size);
    }
  puts(" [EOL]\n");
  fflush(stdout);
  return (0);
}
