/*
** strtab.c for libelfsh
** 
** Started on  Sun Mar 10 03:24:23 2002 mayhem
** Last update Thu May 15 11:30:24 2003 mayhem
*/
#include "libelfsh.h"




/* Add a symbol name in .strtab */
int		elfsh_insert_in_strtab(elfshobj_t *file, char *name)
{
  elfshsect_t	*sect;
  
  if (file == NULL || name == NULL)
    ELFSH_SETERROR("[libelfsh] Invalid NULL parameter\n", -1);
  sect = elfsh_get_section_by_name(file, ELFSH_SECTION_NAME_STRTAB, NULL, NULL, NULL);
  if (sect == NULL)
    {
      sect = elfsh_rebuild_strtab(file);
      if (sect == NULL)
	return (-1);
    }
  return (elfsh_append_data_to_section(sect, name, strlen(name) + 1));
}

/* Add a symbol name in .dynstr */
int		elfsh_insert_in_dynstr(elfshobj_t *file, char *name)
{
  elfshsect_t	*sect;
  
  if (file == NULL || name == NULL)
    ELFSH_SETERROR("[libelfsh] Invalid NULL parameter\n", -1);
  sect = elfsh_get_section_by_name(file, ELFSH_SECTION_NAME_DYNSTR, NULL, NULL, NULL);
  if (sect == NULL)
    ELFSH_SETERROR("[libelfsh] No .dynstr section\n", -1);
  return (elfsh_append_data_to_section(sect, name, strlen(name) + 1));
}


/* Add a section name in .shstrtab */
int		elfsh_insert_in_shstrtab(elfshobj_t *file, char *name)
{
  if (name == NULL || file == NULL || 
      file->secthash[ELFSH_SECTION_SHSTRTAB] == NULL)
    ELFSH_SETERROR("[libelfsh:insert_in_shstrtab] Invalid NULL parameter\n", -1);  
  return (elfsh_append_data_to_section(file->secthash[ELFSH_SECTION_SHSTRTAB], 
				       name, strlen(name) + 1));
}




