/*
** rel.c for elfsh
** 
** Started on  Fri Nov  2 15:19:19 2001 mayhem
** Last update Sun Mar 30 03:00:11 2003 mayhem
*/
#include "elfsh.h"




/* Display relocation entries */
int		cmd_rel()
{
  elfshsect_t	*sect;
  Elf32_Rel	*rel;
  regex_t	*tmp;
  char		*type;
  char		*typeshort;
  char		*name;
  u_int		index;
  u_int		index2;
  u_int		typenum;
  char		buff[256];

  /* Sanity checks */
  sect = elfsh_get_reloc(world.current, 0, NULL);
  if (sect == NULL)
    RET(-1);

  /* Choose between global or local regx */
  CHOOSE_REGX(tmp);
  printf(" [RELOCATION TABLES]\n [Object %s]\n\n", world.current->name);

  /* We need to iterate as much as there is .rel* sections */
  for (index2 = 0; sect; index2++)
    {
      
      printf(" {Section %s} \n", elfsh_get_section_name(world.current, sect));
      
      /* Reverse the associated symbol for each entry of the section */
      for (index = 0, rel = sect->data; 
	   index < sect->shdr->sh_size / sizeof(Elf32_Rel); 
	   index++)
	{
	  
	  name = elfsh_get_symname_from_reloc(world.current, rel + index);
	  typenum   = elfsh_get_reltype(rel + index);
	  type      = (char *) (typenum > ELFSH_RELOC_MAX ? NULL : 
				elfsh_rel_type[typenum].desc);
	  typeshort = (char *) (typenum > ELFSH_RELOC_MAX ? NULL : 
				elfsh_rel_type[typenum].name);
	
	  /* Output is different depending on the quiet flag */
	  if (!world.state.vm_quiet)
	    snprintf(buff, sizeof(buff), 
		     " [%03u] %-15s %-10p sym[%03u] : %-30s => %s",
		     index, typeshort, 
		     (void *) elfsh_get_reloffset(rel + index), 
		     elfsh_get_relsym(rel + index),
		     (name != NULL ? name : "<?>"), type);
	  else
	    snprintf(buff, sizeof(buff), 
		     " [%03u] %-15s %-10p sym[%03u] : %-22s",
		     index, typeshort, 
		     (void *) elfsh_get_reloffset(rel + index), 
		     elfsh_get_relsym(rel + index),
		     (name != NULL ? name : "<?>"));

	  /* Print it if it matchs the regex */
	  if (NULL == tmp || (tmp != NULL && name != NULL && 
			      NULL == regexec(tmp, buff, 0, 0, 0)))
	    puts(buff);
	}

      sect = elfsh_get_reloc(world.current, index2 + 1, NULL);
      puts("");
    }

  puts("");
  return (0);
}

